#line 1 "C:/Ds/Elettronica/pic/Progetti/AntifurtoCasaBase2/AntifurtoCasa.c"
#line 13 "C:/Ds/Elettronica/pic/Progetti/AntifurtoCasaBase2/AntifurtoCasa.c"
unsigned char ScattiMax;
unsigned char RitChius;
unsigned char RitApert;
unsigned char ScattiMem;
unsigned char cnt;
unsigned char OldState;
unsigned char CntAll;
unsigned int CntReset;
#line 47 "C:/Ds/Elettronica/pic/Progetti/AntifurtoCasaBase2/AntifurtoCasa.c"
void Salita (void);
void Discesa (void);
void AntOn (void);
void AntOff (void);
void Allarme (void);



void main (void){





 TRISA = 0;
 PORTA = 0;


 TRISB = 0xFF;


 TRISC = 0;
 PORTC = 0;


 INTCON = 0x00;
 OPTION_REG = 0x00;

  PORTC.B2  = 1;
  PORTC.B3  = 1;
  PORTC.B4  = 1;
  PORTC.B5  = 1;


 ScattiMax = Eeprom_Read(0);
 Delay_ms(500);
 RitChius = Eeprom_Read(1);
 Delay_ms(500);
 RitApert = Eeprom_Read(2);
 Delay_ms(500);
 ScattiMem = Eeprom_Read(3);



 ScattiMax = 250;
 RitChius = 60;
 RitApert = 60;










 if( RB1_bit  == 1){
 OldState = 0;
 }
 if( RB1_bit  == 0 && OldState == 0){
 OldState = 1;
 }
 while(1) {

 if( Button(&PORTB,2,10,0) ) {
 Salita();
 }

 if( Button(&PORTB,3,10,0) ) {
 Discesa();
 }
 if( RB1_bit  == 1 && OldState == 1){
 OldState = 0;
 AntOff();
 }
 if( RB1_bit  == 0 && OldState == 0){
 OldState = 1;
 AntOn();
 }
 if( RB5_bit  == 0) {
  PORTC.B4  = 1;
 }
 if( RB5_bit  == 1) {
  PORTC.B4  = 0;
 }
 if ( RB4_bit  ==  1 ) {
 while( RB4_bit  ==  1 ){
 }
 CntAll++;
 }
 if (CntAll > 3) {
 Allarme();
 Delay_ms(1000);
 CntAll = 0;
 }
 CntReset++;
 if (CntReset > 65000) {
 CntReset = 0;
 CntAll = 0;
 }
 }
}

void Salita (void){
 Delay_ms(100);
  PORTC.B1  = 0;
 cnt = 0;
  PORTC.B0  = 1;
 Delay_ms(1000);
 if( Button(&PORTB,2,10,0) ){
 while( Button(&PORTB,2,10,0) ){
  PORTC.B0  = 1;
 Delay_ms(10);
 }
 }else{
 for(cnt = 0; cnt < ScattiMax; cnt++){
 Delay_ms(100);
 if ( Button(&PORTB,2,10,0) ) {
 goto FermaSalita;
 }
 if ( Button(&PORTB,3,10,0) ) {
 goto FermaSalita;
 }
 }
 }
  PORTC.B0  = 0;
 FermaSalita:
 Delay_ms(200);
}

void Discesa (void){
 if ( RB5_bit  == 0){
 Delay_ms(100);
  PORTC.B0  = 0;
 cnt = 0;
  PORTC.B1  = 1;
 Delay_ms(1000);
 if( Button(&PORTB,3,10,0) ){
 while( Button(&PORTB,3,10,0) ){
  PORTC.B1  = 1;
 Delay_ms(10);
 }
 }else{

 for(cnt = 0; cnt < ScattiMax; cnt++){
 Delay_ms(100);
 if ( Button(&PORTB,2,10,0) ) {
 goto FermaDiscesa;
 }
 if ( Button(&PORTB,3,10,0) ) {
 goto FermaDiscesa;
 }
 if ( RB5_bit  == 1) {
 goto FermaDiscesa;
 }
 }
 }
 }else{
 while( Button(&PORTB,3,10,0) ){
  PORTC.B1  = 1;
 Delay_ms(10);
 }
 }
  PORTC.B1  = 0;
 FermaDiscesa:
 Delay_ms(200);
}

void Allarme (void){

for(cnt = 0; cnt < 20; cnt++){
  PORTA.B2  = 1;
  PORTA.B5  = 1;
 if ( RB4_bit  ==  1 ) {
  PORTC.B2  = 0;
 }
 Delay_ms(200);
  PORTA.B2  = 0;
  PORTA.B5  = 0;
 Delay_ms(200);
}
for(cnt = 0; cnt < 255; cnt++){
 if ( RB4_bit  ==  1 ) {
  PORTC.B2  = 0;
 }
 Delay_ms(100);
}




 PORTA.B5  = 0;
 PORTA.B2  = 0;
Delay_ms(5000);
 PORTC.B2  = 1;
}

void AntOff (void){
 cnt = 0;
  PORTC.B1  = 0;
  PORTC.B0  = 0;
 for(cnt = 0; cnt < RitApert; cnt++){
 Delay_ms(1000);
 }
 if( RB1_bit  == 1){
 Salita();
 }
}

void AntOn (void){
 cnt = 0;
  PORTC.B0  = 0;
  PORTC.B1  = 0;
 for(cnt = 0; cnt < RitApert; cnt++){
 Delay_ms(1000);
 }
 if( RB1_bit  == 0){
 Discesa();
 }
}
